'use strict';

var _Text = require('../Text');

var _Text2 = _interopRequireDefault(_Text);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

test('basic', () => {
  const text = new _Text2.default('foo');
  expect(text.lines).toEqual(['foo']);
  expect(text.width).toBe(3);
  expect(text.height).toBe(1);
});

test('multi-line', () => {
  const text = new _Text2.default('multi\nline');
  expect(text.lines).toEqual(['multi', 'line']);
  expect(text.width).toBe(5);
  expect(text.height).toBe(2);
});

test('removes tabs', () => {
  const text = new _Text2.default('multi\t\nline');
  expect(text.lines).toEqual(['multi', 'line']);
  expect(text.width).toBe(5);
  expect(text.height).toBe(2);
});

it('handles blank lines', () => {
  const text = new _Text2.default('multi\n    ');
  expect(text.lines).toEqual(['multi']);
  expect(text.width).toBe(5);
  expect(text.height).toBe(1);
});